﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
   public  class ClassStudent
    {
       private int numClass;//מספר כיתה
       private Student[] arrStudents;//מערך תלמידים
       private int currentStudent;//מספר תלמיד נוכחי
       public const int maxStudent = 40;
       public ClassStudent(int numClass)
       {
           this.numClass = numClass;
           this.arrStudents = new Student[maxStudent];
           this.currentStudent = 0;
       }
       public int GetNumClassStudent()
       {
           return this.numClass;
       }
       public Student[] GetArrStudents()
       {
           return this.arrStudents;
       }
       //פעולה המוסיפה תלמיד
       public void AddStudent(Student s)
       {
           if (this.currentStudent < maxStudent)
           {
               this.arrStudents[currentStudent] = s;
               this.currentStudent++;
           }
           else Console.WriteLine("Connot Add Student The Class Is Full");
       }
       //פעולה מחזירה מספר התלמידים שממוצע שלהם מעל 110
       public int NumberInncocentInClass()
       {
           int c = 0;
           for (int i = 0; i < this.currentStudent; i++)
               if (arrStudents[i].IsInncocent()==true)
                   c++;
           return c;
       }
       //פעולה מוסיפה תלמיד לפי הפרמטרים
       public void AddStudent(string id, string name)
       {
           if (this.currentStudent < maxStudent)
           {
               this.arrStudents[currentStudent] = new Student(name, id);
               this.currentStudent++;
           }
           else Console.WriteLine("Connot Add Student The Class Is Full");
       }
       //פעולה המוחקת תלמיד מהכיתה
       public void RemoveStudent(Student s)
       {

           int place = -1;
           for (int i = 0; i < this.currentStudent; i++)
               if (arrStudents[i] == s)
                   place = i;
           if (place != -1)
           {
               arrStudents[place] = arrStudents[this.currentStudent];
               arrStudents[this.currentStudent] = null;
           }
           else Console.WriteLine("The Student Not Found");
       }
       public void RemoveStudent(string  id)
       {

           int place = -1;
           for (int i = 0; i < this.currentStudent; i++)
               if (arrStudents[i].GetId() == id)
                   place = i;
           if (place != -1)
           {
               arrStudents[place] = arrStudents[this.currentStudent];
               arrStudents[this.currentStudent] = null;
           }
           else Console.WriteLine("The Student Not Found");
       }

       //פעולה הבודקת האם תלמיד בעל ת.ז נמצא בכיתה
       public bool StudentExists(string id)
       {
           for (int i = 0; i < this.currentStudent; i++)
               if (arrStudents[i].GetId() == id)
                   return true;
           return false;
       }
       //פעולה מחזירה ממוצע הכיתה
       public double GetAverageClass()
       {
           double sum = 0;
           for (int i = 0; i < this.currentStudent; i++)
               sum = sum + this.arrStudents[i].GetAverage();
           return sum / this.currentStudent;
       }
       //פעולה המחזירה מספר תלמיד בעל ת.ז מסויימת
       public int GetPlaceStudent(string id)
       {
           int place = -1;
           for (int i = 0; i < this.currentStudent; i++)
               if (arrStudents[i].GetId() == id)
                   place = i;
           return place;
       }
       //פעולה מממינת את התלמידידם לפי שם
       public void SortNameStudent()
       {
           Student temp;
           for (int i=0;i<this.currentStudent;i++)
               for(int j=i+1;j<this.currentStudent;j++)
                   if (arrStudents[i].GetNameStudent().CompareTo(arrStudents[j].GetNameStudent())>0)
                   {
                       temp=arrStudents[i];
                       arrStudents[i]=arrStudents[j];
                       arrStudents[j]=temp;
                   }

       }
     
       public void PrintBestStudent()
       {

           for (int i = 0; i < this.currentStudent; i++)
               if (arrStudents[i].GetAverage() > 110)
                   Console.WriteLine("{0} , {1}  , {2:f2}", arrStudents[i].GetId(), arrStudents[i].GetNameStudent(), arrStudents[i].GetAverage());


       }
       public override string ToString()
       {
           string s="";
           for (int i = 0; i < this.currentStudent; i++)
               s = s + arrStudents[i].GetNameStudent()+"\n";
           return s;
       }

    }
}
