﻿using System;
using Unit4.CollectionsLib;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class School
    {
        private string nameSchool;//שם בית ספר
        private int symbol;//סמל בית ספר
        private List<ClassStudent> listClassStudent;//רשימת כיתות
        public School(string nameSchool, int symbol)
        {
            this.nameSchool = nameSchool;
            this.symbol = symbol;
            this.listClassStudent = new List<ClassStudent>();
        }
        public string GetNameSchool()
        {
            return this.nameSchool;
        }
        public int GetSymbolSchool()
        {
            return this.symbol;
        }
        //פעולה המוסיפה כיתה
        public void AddClassStudent(ClassStudent c)
        {
            this.listClassStudent.Insert(null, c);
        }
        //פעולה מעבירה תלמיד מכיתה לכיתה אחרת
        public void MoveStudent(string  id,string name,int numClassDist)
        {
            Node<ClassStudent> pos = this.listClassStudent.GetFirst();
            Node<ClassStudent> q1=null;
            Node<ClassStudent> q2=null;

            while (pos != null)
            {
                if (pos.GetInfo().StudentExists(id) == true)
                    q1 = pos;
                if (pos.GetInfo().GetNumClassStudent() == numClassDist)
                    q2 = pos;
                pos = pos.GetNext();
            }
            int place = q1.GetInfo().GetPlaceStudent(id);
            if (place != -1)
            {
                q1.GetInfo().RemoveStudent(id);
                q2.GetInfo().AddStudent(id, name);
            }
        }
        //פעולה המחזירה מספר התלמידים הזכאים לתעודת בגרות
        public int InncocentNumber()
        {
            Node<ClassStudent> pos = this.listClassStudent.GetFirst();
            int sum=0;
            while (pos != null)
            {
                sum = sum + pos.GetInfo().NumberInncocentInClass();
                pos = pos.GetNext();
            }
            return sum;
        }
        //פעולה המדפיסה כל התלמידים שממוצע הבגרות שלהם מעל 110
        public void PrintBestStudents()
        {
            Node<ClassStudent> pos = this.listClassStudent.GetFirst();
            Console.WriteLine("The Best Students Is:");
            while (pos != null)
            {
                pos.GetInfo().PrintBestStudent();
                pos = pos.GetNext();
            }
        }


    }
}
